library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
--
entity spi_clock is
    Port ( CLK_50 : in  STD_LOGIC;
           x : in  STD_LOGIC;
           DBx : out  STD_LOGIC);
end spi_clock;

architecture Behave of spi_clock is
   signal Shreg: STD_LOGIC_VECTOR( 3 downto 0);
begin

   process( CLK_50)
	   variable Scale: STD_LOGIC_VECTOR( 15 downto 0); -- 65535
	begin
	   if rising_edge( CLK_50) then
		   Scale := Scale+1;
			if Scale(15)='1' then
			   Scale := (others=>'0');
				Shreg <= Shreg(2 downto 0) & x;
				if Shreg="0000" then 
				   DBx <= '0';
				elsif Shreg="1111" then 
				   DBx <= '1';
				end if;
			end if;
		end if;
	end process;

end Behave;

