library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_arith.ALL;
use IEEE.std_logic_unsigned.ALL;

entity tb_Master_top is
end tb_Master_top;

architecture tb of tb_Master_top is

    component Master_top
        port (CLK_50 : in std_logic;
              x      : in std_logic;
              RESET  : in std_logic;
              Datain : in std_logic_vector (15 downto 0);
              SCLK   : out std_logic;
              MOSI   : out std_logic;
              MISO   : in std_logic;
              CS1    : out std_logic);
    end component;

    signal CLK_50 : std_logic := '0';
    signal x      : std_logic := '0';
    signal RESET  : std_logic := '0';
    signal Datain : std_logic_vector (15 downto 0);
    signal SCLK   : std_logic := '0';
    signal MOSI   : std_logic := '0';
    signal MISO   : std_logic;
    signal CS1    : std_logic;

    constant TbPeriod : time := 1000 ns; -- EDIT put right period here
	
	
	--signal data_serial : std_logic:= '0';
	--signal data_serial_vector : std_logic_vector ( 15 downto 0);

begin

    dut : Master_top
    port map (CLK_50 => CLK_50,
              x      => x,
              RESET  => RESET,
              Datain => Datain,
              SCLK   => SCLK,
              MOSI   => MOSI,
              MISO   => MISO,
              CS1    => CS1);

   RESET <= '0' after 110 ns;
   CLK_50 <= not CLK_50 after 50 ns;
			  
			  
    -- CLK_50 <=  not CLK_50 after TbPeriod;

-- process 
-- begin
-- RESET <= '0';
-- wait for TbPeriod + 10 ns;
-- RESET <= '1';
-- wait for TbPeriod + 20 ns;
-- RESET <= '0';
-- --wait;
-- end process;

-- process 
-- begin
-- x <= '0';
-- wait for TbPeriod + 20 ns;
-- x <= '1';
-- wait for TbPeriod + 40 ns;
-- x <= '0';
-- --wait;
-- end process;
-- **************************************************************

-- *********** Generating data **********************************
-- Datain <= "1100110011001100"; -- 16 Bit

-- process
-- begin
-- for i in 15 downto 0 loop
-- wait until sclk = '0' and sclk'event;
-- MOSI <= Datain(i);
-- end loop;
-- end process;


   -- process

	-- variable err_cnt: integer :=0; 

    -- begin
	
	-- -- case 1
	-- wait for 30 ns;
	-- assert(MOSI='0') report "Test1 Failed !"
	-- severity error;			 
	-- if (MOSI/='0') then
	    -- err_cnt:=err_cnt+1;
	-- end if;
-- end process;

end tb;

